<template>
  <div class="mod-config" style="height:100%;">
    <div class="avue-crud" style="width: 100%;height:100%;">
      <div style="display:flex;height:100%;">
        <div style="width:35%;padding-left:20px;">
          <div style="margin-bottom:20px;margin-top:20px;">
            <div style="height:60px;background:yellow;">
              扫码请对号入座，按下【Enter】键移动光标，聚焦下一个输入框
            </div>
          </div>
          <div style="margin-bottom:20px;">
            <div style="color:red;font-weight:bold;margin-bottom:5px;">
              新MES码：
            </div>
            <div>
              <el-input
                ref="mes_no_input"
                type="textarea"
                v-textareafocus
                :rows="6"
                v-model="mesNo"
                @keyup.enter.native="jumpToPkg"
              >
              </el-input>
            </div>
          </div>

          <div style="margin-bottom:20px;">
            <div style="color:red;font-weight:bold;margin-bottom:5px;">
              PKG：
            </div>
            <div>
              <el-input
                ref="pkg_no_input"
                v-model="pkgNo"
                @keyup.enter.native="jumpToCe"
              ></el-input>
            </div>
          </div>
          <div style="margin-bottom:20px;">
            <div style="color:red;font-weight:bold;margin-bottom:5px;">
              CE／称重标签：
            </div>
            <div>
              <el-input
                ref="ce_no_input"
                v-model="ceNo"
                @keyup.enter.native="jumpToBind"
              ></el-input>
            </div>
          </div>
          <div style="display:flex;justify-content:center;margin-top:50px;">
            <div style="text-align:center;">
              <el-input
                class="bind-input-class"
                ref="bind_input"
                @keyup.enter.native="bindRelate"
              ></el-input>
              <el-button
                :class="[bindFocus ? 'bind-focus-btn-class' : 'bind-btn-class']"
                round
                ref="bind_btn"
                @click="bindRelate"
                >绑定</el-button
              >
            </div>
            <div style="text-align:center;">
              <el-input
                class="clear-input-class"
                ref="clear_input"
                @keyup.enter.native="clearContent"
              ></el-input>
              <el-button
                :class="[
                  clearFocus ? 'clear-focus-btn-class' : 'clear-btn-class'
                ]"
                round
                ref="clear_btn"
                @click="clearContent"
                >清除</el-button
              >
            </div>
          </div>
        </div>
        <div style="width:60%;padding-top:20px;">
          <ttable
            :table="table"
            :uploadInfo="uploadInfo"
            :prelang="prelang"
            :options="options"
            :bottomOffset="40"
            :ajaxFun="ajaxFun"
            ref="pkgidbindTable"
          >
            <template #toolbar></template>
          </ttable>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import ttable from '@/views/common/ztt-table.vue'
import { addObj, fetchList, delZxlabelbind } from '@/api/zte/zxlabelbind'
import { mapGetters } from 'vuex'
export default {
  data() {
    return {
      ajaxFun: fetchList,
      uploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: false,
        url: ''
      },
      prelang: 'pkgidbind',
      options: {
        height: 300, // 默认高度-为了表头固定
        stripe: true, // 是否为斑马纹 table
        highlightCurrentRow: false, // 是否要高亮当前行
        border: true, // 是否有纵向边框
        lazy: false, // 是否需要懒加载
        fit: true, // 列的宽度是否自撑开
        multiSelect: true, //
        seqNo: true,
        isShowHide: true, // 是否显示显影按钮
        isRefresh: true,
        isSearch: false, // 高级查询按钮
        defaultOrderBy: { column: 'id', direction: 'desc' }
      },
      table: {
        total: 0,
        currentPage: 1,
        pageSize: 20,
        data: [],
        // 标题
        column: [
          // pkg条码
          {
            minWidth: '30',
            prop: 'pkgCode',
            label: 'pkg条码',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 长度
          {
            minWidth: '120',
            prop: 'quantity',
            label: '长度',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 物料编号
          {
            minWidth: '140',
            prop: 'partNo',
            label: '物料编号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 批次号
          {
            minWidth: '140',
            prop: 'lotBatchNo',
            label: '批次号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // CE码
          {
            minWidth: '140',
            prop: 'ceCode',
            label: 'CE码',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 操作人
          {
            minWidth: '120',
            prop: 'createUser',
            label: '操作人',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '200',
            prop: 'createTime',
            label: '操作时间',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'datetimerange'
          }
        ],
        toolbar: [],
        operator: [
          {
            text: '删除',
            type: 'text',
            size: 'small',
            fun: this.deleteHandle
          }
        ],
        operatorConfig: {
          fixed: 'right',
          label: '操作',
          width: 100,
          minWidth: 100
        }
      },
      mesNo: null,
      pkgNo: null,
      ceNo: null,
      bottomOffset: 20,
      fixedHeight: 0,
      clearFocus: false,
      bindFocus: false
    }
  },
  components: {
    ttable
  },

  computed: {
    ...mapGetters(['permissions'])
  },
  directives: {
    focus: {
      inserted: function(el, option) {
        var defClass = 'el-input'
        var defTag = 'input'
        var value = option.value || true
        if (typeof value === 'boolean')
          value = { cls: defClass, tag: defTag, foc: value }
        else
          value = {
            cls: value.cls || defClass,
            tag: value.tag || defTag,
            foc: value.foc || false
          }
        // if (el.classList.contains(value.cls) && value.foc)
        el.getElementsByTagName(value.tag)[0].focus()
      }
    },
    textareafocus: {
      inserted: function(el, option) {
        var defClass = 'el-textarea'
        var defTag = 'textarea'
        var value = option.value || true
        if (typeof value === 'boolean')
          value = { cls: defClass, tag: defTag, foc: value }
        else
          value = {
            cls: value.cls || defClass,
            tag: value.tag || defTag,
            foc: value.foc || false
          }
        // if (el.classList.contains(value.cls) && value.foc)
        el.getElementsByTagName(value.tag)[0].focus()
      }
    }
  },
  mounted() {
    this.$nextTick(() => {
      this.$refs.mes_no_input.focus()
    })
  },
  methods: {
    jumpToPkg() {
      this.bindFocus = false
      this.clearFocus = false
      this.$refs.pkg_no_input.focus()
    },
    jumpToCe() {
      this.bindFocus = false
      this.clearFocus = false
      this.$refs.ce_no_input.focus()
    },
    jumpToBind() {
      this.bindFocus = true
      this.clearFocus = false
      this.$refs.bind_input.focus()
    },
    bindRelate() {
      if (this.ceNo != null && this.ceNo.trim() != '') {
      } else {
        this.$message.error('CE／称重标签不能为空')
        return
      }
      if (this.pkgNo != null && this.pkgNo.trim() != '') {
      } else {
        this.$message.error('pkg码不能为空')
        return
      }
      if (this.mesNo != null && this.mesNo.trim() != '') {
      } else {
        this.$message.error('新mes码不能为空')
        return
      }
      try {
        const mesNoObj = JSON.parse(this.mesNo.trim())
        const paramObj = {
          ceCode: this.ceNo,
          pkgCode: this.pkgNo,
          mesNode: mesNoObj,
          shopCode: 'GD'
        }
        addObj(paramObj).then(() => {
          this.$message.success('绑定成功')
          this.getData().then(() => {
            this.bindFocus = false
            this.clearFocus = true
            this.$refs.clear_input.focus()
          })
        })
      } catch (err) {
        this.$message.error('新mes码格式错误')
      }
    },
    clearContent() {
      this.mesNo = null
      this.ceNo = null
      this.pkgNo = null
      console.log('2')
      this.clearFocus = false
      this.bindFocus = false
      this.$refs.mes_no_input.focus()
    },
    deleteHandle(row) {
      delZxlabelbind([row.id]).then((response) => {
        this.$message.success('删除成功')
        this.getData().then(() => {
          this.$refs.mes_no_input.focus()
        })
      })
    },
    getData() {
      return this.$refs.pkgidbindTable.getDataList()
    }
  }
}
</script>
<style lang="scss" scoped>
.bind-input-class {
  height: 0px;
}
.bind-input-class >>> .el-input__inner {
  height: 0px;
  border: 0px solid #ddd;
}
.clear-input-class {
  height: 0px;
}
.clear-input-class >>> .el-input__inner {
  height: 0px;
  border: 0px solid #ddd;
}
.clear-focus-btn-class.el-button {
  color: #006eff;
  border-color: #b3d4ff;
  background-color: #e6f1ff;
}
.clear-btn-class {
  color: #606266;
  border-color: #dcdfe6;
  background-color: #fff;
}
.bind-focus-btn-class {
  color: #006eff;
  border-color: #b3d4ff;
  background-color: #e6f1ff;
}
.bind-btn-class {
  color: #606266;
  border-color: #dcdfe6;
  background-color: #fff;
}
</style>
